function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * 考勤记录
 */
import { useSetState } from 'ahooks';
import { Tag } from 'antd';
import dayjs from 'dayjs';
import { VmExtraTab, VmTable, VmWrapper } from "../../../_components";
import { AttendanceService } from "../../api";
import { jsx as _jsx } from "react/jsx-runtime";
export default function Record(props) {
  var id = props.id,
    service = props.service;
  var _useSetState = useSetState({
      startDate: dayjs().startOf('M'),
      endDate: dayjs(),
      shiftClockWay: 'CLOCK_IN_OUT',
      pagination: {
        current: 1,
        pageSize: 10,
        total: 0
      }
    }),
    _useSetState2 = _slicedToArray(_useSetState, 2),
    state = _useSetState2[0],
    setState = _useSetState2[1];
  var pagination = state.pagination,
    startDate = state.startDate,
    endDate = state.endDate,
    shiftClockWay = state.shiftClockWay;
  var _AttendanceService$us = AttendanceService.useAttendRecord(id, "".concat(startDate.format('YYYY-MM-DD'), " 00:00:00"), "".concat(endDate.format('YYYY-MM-DD'), " 23:59:59"), pagination.current - 1, service, shiftClockWay),
    attendRecordRes = _AttendanceService$us.attendRecordRes;
  var records = {
    total: (attendRecordRes === null || attendRecordRes === void 0 ? void 0 : attendRecordRes.total) || 0,
    rows: (attendRecordRes === null || attendRecordRes === void 0 ? void 0 : attendRecordRes.rows) || []
  };
  var getColor = function getColor(code) {
    var color = '';
    switch (code) {
      case 'Normal':
        color = 'green';
        break;
      case 'Late':
      case 'Early':
        color = 'red';
        break;
      case 'Leave':
      case 'Absent':
        color = 'orange';
        break;
      default:
        color = 'warning';
        break;
    }
    return color;
  };
  var isClockInOut = shiftClockWay === 'CLOCK_IN_OUT';
  var columns = [{
    title: '所属机构',
    dataIndex: 'deptName',
    key: 'deptName',
    width: 120,
    ellipsis: true
  }, {
    title: '姓名',
    dataIndex: 'staffName',
    key: 'staffName',
    ellipsis: true
  }, {
    title: '班次',
    dataIndex: 'shiftName',
    key: 'shiftName',
    width: 100,
    ellipsis: true
  }, {
    title: '开始时间',
    dataIndex: 'shiftStartTime',
    key: 'shiftStartTime',
    width: 160
  }, {
    title: '结束时间',
    dataIndex: 'shiftEndTime',
    key: 'shiftEndTime',
    width: 160
  }, {
    title: '排班区域',
    dataIndex: 'shiftWorkElementNames',
    key: 'shiftWorkElementNames',
    width: 100,
    ellipsis: true
  }, isClockInOut && {
    title: '上班时间',
    dataIndex: 'clockInTime',
    key: 'clockInTime',
    width: 140,
    render: function render(text) {
      return text ? text : '-';
    }
  }, isClockInOut && {
    title: '上班状态',
    dataIndex: 'clockInStatusName',
    key: 'clockInStatusName',
    width: 80,
    render: function render(text, record) {
      return record.clockInStatusCode ? /*#__PURE__*/_jsx("div", {
        style: {
          color: getColor(record.clockInStatusCode)
        },
        children: /*#__PURE__*/_jsx(Tag, {
          color: getColor(record.clockInStatusCode),
          children: text
        })
      }) : '--';
    }
  }, isClockInOut && {
    title: '下班时间',
    dataIndex: 'clockOutTime',
    key: 'clockOutTime',
    width: 140,
    render: function render(text) {
      return text ? text : '-';
    }
  }, isClockInOut && {
    title: '下班状态',
    dataIndex: 'clockOutStatusName',
    key: 'clockOutStatusName',
    width: 80,
    render: function render(text, record) {
      return record.clockOutStatusCode ? /*#__PURE__*/_jsx("div", {
        style: {
          color: getColor(record.clockOutStatusCode)
        },
        children: /*#__PURE__*/_jsx(Tag, {
          color: getColor(record.clockOutStatusCode),
          children: text
        })
      }) : '--';
    }
  }, !isClockInOut && {
    title: '打卡时间',
    dataIndex: 'clockInTime',
    key: 'clockInTime',
    width: 140,
    render: function render(text) {
      return text ? text : '-';
    }
  }, !isClockInOut && {
    title: '打卡状态',
    dataIndex: 'clockInStatusName',
    key: 'clockInStatusName',
    width: 80,
    render: function render(text, record) {
      return /*#__PURE__*/_jsx("div", {
        style: {
          color: getColor(record.clockInStatusCode)
        },
        children: /*#__PURE__*/_jsx(Tag, {
          color: getColor(record.clockInStatusCode),
          children: text
        })
      });
    }
  }, {
    title: '用工类型',
    dataIndex: 'workTypeName',
    key: 'workTypeName',
    width: 80,
    ellipsis: true
  }].filter(function (item) {
    return !!item;
  });
  var pageChange = function pageChange(page) {
    setState({
      pagination: _objectSpread(_objectSpread({}, pagination), {}, {
        current: page
      })
    });
  };
  var tableProps = {
    pagination: _objectSpread(_objectSpread({}, pagination), {}, {
      total: records.total,
      defaultPageSize: 10,
      onChange: pageChange
    }),
    style: {
      padding: '0 20px'
    },
    height: 132,
    dataSource: records.rows
  };
  var handleDateChange = function handleDateChange(dates) {
    setState({
      startDate: dates[0],
      endDate: dates[1]
    });
  };
  return /*#__PURE__*/_jsx("div", {
    children: /*#__PURE__*/_jsx(VmWrapper, {
      title: "\u8003\u52E4\u8BB0\u5F55",
      dateValue: [dayjs(startDate), dayjs(endDate)],
      filterType: "rangePicker",
      filterChange: function filterChange(dates) {
        return dates && handleDateChange(dates);
      },
      extra: service ? /*#__PURE__*/_jsx(VmExtraTab, {
        data: [{
          key: 'CLOCK_IN_OUT',
          title: '上下班打卡'
        }, {
          key: 'SHIFT_CHECK_IN',
          title: '班次内打卡'
        }],
        value: shiftClockWay,
        onChange: function onChange(key) {
          setState({
            shiftClockWay: key,
            pagination: {
              current: 1,
              pageSize: 10,
              total: 0
            }
          });
        }
      }) : null,
      children: /*#__PURE__*/_jsx(VmTable, _objectSpread({
        columns: columns,
        rowKey: "id"
      }, tableProps))
    })
  }, id);
}